'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.capitalize');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RESIZE = 'resize orientationchange';
var toArray = function toArray(item) {
  return item instanceof Array ? item : [item];
};

var ReactFreeCarousel = function (_React$Component) {
  _inherits(ReactFreeCarousel, _React$Component);

  function ReactFreeCarousel(props) {
    _classCallCheck(this, ReactFreeCarousel);

    var _this = _possibleConstructorReturn(this, (ReactFreeCarousel.__proto__ || Object.getPrototypeOf(ReactFreeCarousel)).call(this, props));

    _this.state = {
      page: _this.props.page || 0,
      pages: 0
    };
    _this.gotoPage = _this.gotoPage.bind(_this);
    _this.reRender = _this.reRender.bind(_this);
    return _this;
  }

  _createClass(ReactFreeCarousel, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        var totalPages = _this2.calculateTotalPages();

        _this2.setState({ pages: totalPages });
        _this2.playCarousel();
        if (_this2.props.slide > 0) {
          _this2.gotoTile(_this2.props.slide);
        } else if (_this2.props.page > 0) {
          _this2.gotoPage(_this2.props.page);
        }
        (0, _jquery2.default)(window).on(RESIZE, (0, _lodash2.default)(_this2.reRender, 500));
      }, 100);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this3 = this;

      if (toArray(nextProps.children).length !== toArray(this.props.children).length) {
        setTimeout(function () {
          _this3.reRender(false);
        }, 200);
      }
      setTimeout(function () {
        _this3.playCarousel();
      }, 210);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.stopCarousel();
      (0, _jquery2.default)(window).off(RESIZE, this.reRender);
    }
  }, {
    key: 'reRender',
    value: function reRender() {
      var _this4 = this;

      var scrollToStart = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

      var totalPages = this.calculateTotalPages();
      var page = scrollToStart && this.state.pages !== totalPages ? 0 : this.state.page;

      if (page > totalPages) {
        page = totalPages;
      }

      this.stopCarousel();

      if (page === 0) {
        (0, _jquery2.default)(this.container).css('margin-left', '0px');
      }

      setTimeout(function () {
        _this4.setState({
          page: page,
          pages: totalPages
        }, function () {
          _this4.gotoPage(page);
          _this4.playCarousel();
        });
      }, this.props.transitionSpeed + 50);
    }
  }, {
    key: 'stopCarousel',
    value: function stopCarousel() {
      if (this.slidingInterval) {
        clearInterval(this.slidingInterval);
      }
    }
  }, {
    key: 'playCarousel',
    value: function playCarousel() {
      var _this5 = this;

      this.stopCarousel();
      if (this.state.pages > 0 && this.props.autoplay && this.props.interval) {
        this.slidingInterval = setInterval(function () {
          var page = _this5.state.page === _this5.state.pages ? 0 : _this5.state.page + 1;

          _this5.gotoPage(page);
        }, this.props.interval);
      }
    }
  }, {
    key: 'gotoPage',
    value: function gotoPage(page) {
      var _this6 = this;

      var newPage = page > this.state.pages ? 0 : page;

      this.stopCarousel();
      this.setState({ page: newPage }, function () {
        _this6.playCarousel();
      });
      (0, _jquery2.default)(this.container).css('margin-left', '-' + this.pageToOffset(newPage) + 'px');
    }
  }, {
    key: 'gotoTile',
    value: function gotoTile(index) {
      var $container = (0, _jquery2.default)(this.container);
      var $tile = (0, _jquery2.default)($container.children().get(index));

      if ($tile.length) {
        this.gotoPage(Number($tile.attr('data-page')));
      }
    }
  }, {
    key: 'pageToOffset',
    value: function pageToOffset(page) {
      var $container = (0, _jquery2.default)(this.container);
      var $target = $container.children('[data-page=' + page + '][data-first=true]');

      if ($target.length) {
        return parseInt((0, _jquery2.default)($target.get(0)).attr('data-offset'), 10);
      }
      return 0;
    }
  }, {
    key: 'renderTile',
    value: function renderTile(tile) {
      return tile;
    }
  }, {
    key: 'calculateTotalPages',
    value: function calculateTotalPages() {
      var $container = (0, _jquery2.default)(this.container);
      var $children = $container.children();
      var wrapperWidth = this.wrapper.clientWidth;
      var offsetPage = new Map();
      var pageOffset = new Map();
      var pages = 0;

      $children.each(function (index, tile) {
        var $tile = (0, _jquery2.default)(tile);
        var tileLeft = tile.offsetLeft - parseInt(window.getComputedStyle(tile).marginLeft, 10);
        var tileWidth = tile.clientWidth;

        if (offsetPage.has(tileLeft)) {
          $tile.attr('data-first', 'false');
          $tile.attr('data-page', offsetPage.get(tileLeft));
          $tile.attr('data-offset', tileLeft);
        } else {
          var currentPageOffset = pageOffset.get(pages) || 0;

          // check if the tile fully fit in the current page
          if (tileLeft >= currentPageOffset && tileLeft + tileWidth <= currentPageOffset + wrapperWidth) {
            if (index === 0) {
              $tile.attr('data-first', 'true');
            }
          } else {
            pages = pages + 1;
            $tile.attr('data-first', 'true');
          }
          $tile.attr('data-page', pages);
          $tile.attr('data-offset', tileLeft);
          offsetPage.set(tileLeft, pages);
          if (!pageOffset.has(pages)) {
            pageOffset.set(pages, tileLeft);
          }
        }
      });

      return pages;
    }
  }, {
    key: 'prepareParam',
    value: function prepareParam(param) {
      if (typeof param === 'string') {
        return param;
      }

      if (typeof param === 'number') {
        return param + 'px';
      }

      return '100%';
    }
  }, {
    key: 'renderPagination',
    value: function renderPagination() {
      var _this7 = this;

      return _react2.default.createElement(
        'div',
        {
          className: this.props.paginationClass,
          ref: function ref(node) {
            _this7.pagination = node;
          },
          role: 'navigation' },
        [].concat(_toConsumableArray(Array(this.state.pages + 1))).map(function (e, i) {
          return _react2.default.createElement(
            'button',
            {
              'aria-label': 'Goto Page ' + (i + 1),
              className: '\n                ' + _this7.props.paginationDotClass + '\n                ' + (i === _this7.state.page ? _this7.props.paginationDotActiveClass : ''),
              'data-active': i === _this7.state.page ? 'true' : 'false',
              key: i,
              onClick: function onClick() {
                _this7.gotoPage(i);
              } },
            i + 1
          );
        })
      );
    }
  }, {
    key: 'renderArrows',
    value: function renderArrows(kind) {
      var _this8 = this;

      var calculateNextPage = function calculateNextPage(direction) {
        if (direction === 'next' && _this8.state.page < _this8.state.pages) {
          return _this8.state.page + 1;
        }
        if (direction === 'prev' && _this8.state.page > 0) {
          return _this8.state.page - 1;
        }
        return null;
      };

      var nextPage = calculateNextPage(kind);

      return _react2.default.createElement('button', {
        className: this.props['arrow' + (0, _lodash4.default)(kind) + 'Class'],
        disabled: nextPage === null,
        onClick: function onClick() {
          _this8.gotoPage(nextPage);
        },
        role: 'button',
        type: 'button' });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this9 = this;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          width = _props.width,
          height = _props.height,
          transitionSpeed = _props.transitionSpeed,
          showPagination = _props.showPagination,
          minPagesToShowPagination = _props.minPagesToShowPagination,
          arrows = _props.arrows;


      var childrenToRender = Array.isArray(children) ? children : [children];

      var wrapperStyling = {
        position: 'relative',
        width: this.prepareParam(width),
        height: this.prepareParam(height)
      };

      var viewportStyling = {
        position: 'relative',
        width: '100%',
        overflow: 'hidden',
        height: '100%'
      };

      var containerStyling = {
        overflow: 'hidden',
        position: 'relative',
        alignContent: 'flex-start',
        display: 'flex',
        flexDirection: 'column',
        flexWrap: 'wrap',
        height: '100%',
        transition: 'margin-left ' + transitionSpeed + 'ms'
      };

      return _react2.default.createElement(
        'div',
        {
          className: className,
          ref: function ref(node) {
            _this9.wrapper = node;
          },
          style: wrapperStyling },
        _react2.default.createElement(
          'div',
          { style: viewportStyling },
          _react2.default.createElement(
            'div',
            {
              ref: function ref(node) {
                _this9.container = node;
              },
              style: containerStyling },
            childrenToRender && childrenToRender.map(this.renderTile)
          )
        ),
        arrows && this.renderArrows('prev'),
        showPagination && this.state.pages + 1 >= minPagesToShowPagination && this.renderPagination(),
        arrows && this.renderArrows('next')
      );
    }
  }]);

  return ReactFreeCarousel;
}(_react2.default.Component);

exports.default = ReactFreeCarousel;


ReactFreeCarousel.propTypes = {
  children: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.arrayOf(_react2.default.PropTypes.node), _react2.default.PropTypes.node]),
  className: _propTypes2.default.string,
  height: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  width: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  interval: _propTypes2.default.number,
  autoplay: _propTypes2.default.bool,
  showPagination: _propTypes2.default.bool,
  transitionSpeed: _propTypes2.default.number,
  page: _propTypes2.default.number,
  slide: _propTypes2.default.number,
  minPagesToShowPagination: _propTypes2.default.number,
  paginationClass: _propTypes2.default.string,
  paginationDotClass: _propTypes2.default.string,
  paginationDotActiveClass: _propTypes2.default.string,
  arrows: _propTypes2.default.bool,
  arrowPrevClass: _propTypes2.default.string,
  arrowNextClass: _propTypes2.default.string
};

ReactFreeCarousel.defaultProps = {
  className: null,
  interval: 5000,
  transitionSpeed: 500,
  height: '100%',
  width: '100%',
  autoplay: true,
  showPagination: true,
  page: 0,
  slide: null,
  minPagesToShowPagination: 2,
  paginationClass: '',
  paginationDotClass: '',
  paginationDotActiveClass: '',
  arrows: false,
  arrowPrevClass: '',
  arrowNextClass: ''
};